;
;                     ͻ
;                                                          
;                      Zap-Sort - (C) Zappy/Scoopex 1995 
;                                                          
;                      E-Mail: TERDIMAN_P@ESME.FR          
;                                                          
;                     ͼ
;

b equ byte ptr
w equ word ptr
d equ dword ptr

nb_face_des = number of faces in your object

;In:	eax = 1 => init routy
;	eax = 0 => do zap_sort
;Out:	none
zap_sort:
	cmp	eax,d 1
	je	init_sort
do_sort:
	mov	esi,offset ctrl_rot	;control buffer, it contains the 3
					;rotated vertex of the trihedron
	movsx	eax,w ds:[esi+4]	;z1
	movsx	ebx,w ds:[esi+4+6]	;z2
	movsx	ecx,w ds:[esi+4+12]	;z3

	or	eax,eax
	jge	@@c1
	mov	eax,1
	jmp	@@c1b
@@c1:	xor     eax,eax
@@c1b:
	or	ebx,ebx
	jge	@@c2
	mov	ebx,2
	jmp	@@c2b
@@c2:	xor	ebx,ebx
@@c2b:
	or	ecx,ecx
	jge	@@c3
	mov	ecx,4
	jmp	@@c3b
@@c3:	xor	ecx,ecx
@@c3b:
	or	eax,ebx
	or	eax,ecx			;eax = control code

	mov	edi,ds:[eax*4+offset control_table]
	;Here, edi = pointer on the correct pre-sorted buffer.

	mov	ecx,nb_face_des
@@afiobj:	push	ecx
	push	edi

	mov	esi,ds:[edi]            ;adress of the face datas
	call	aff_one_face		;your Polygon_Routine

	pop	edi
	add	edi,4
	pop	ecx
	dec	ecx
	jnz	@@afiobj
	ret




init_sort:
	mov	eax,offset buf_sort
	mov	pt_sort,eax

	mov	ecx,8
	mov	esi,offset dat_sort
@@lp_init:	push	ecx
	push	esi

	mov	eax,d ds:[esi]
	mov	phi,eax
	mov	eax,d ds:[esi+4]
	mov	psi,eax
	mov	eax,d ds:[esi+8]
	mov	theta,eax

	and	phi,d 2047
	and	psi,d 2047
	and	theta,d 2047

	;trihedron rotation
	mov	esi,offset pts
	mov	edi,offset coor_rot
	mov	ecx,n
	call	mk_rotations		;the rotation routy used in the
					;fast_rot algo
	mov	esi,offset coor_rot
	mov	edi,offset obj
	mov	ebp,offset buf_work

	mov	ecx,nb_face_des
@@calc_z:
	xor	edx,edx
	mov	dx,ds:[edi]
	lea	edx,ds:[edx*2+edx]
	add	edx,edx
	mov	ax,ds:[edx+esi+4]
	cwde
	mov	ebx,eax

	xor	edx,edx
	mov	dx,ds:[edi+2]
	lea	edx,ds:[edx*2+edx]
	add	edx,edx
	mov	ax,ds:[edx+esi+4]
	cwde
	add	ebx,eax

	xor	edx,edx
	mov	dx,ds:[edi+4]
	lea	edx,ds:[edx*2+edx]
	add	edx,edx
	mov	ax,ds:[edx+esi+4]
	cwde
	add	ebx,eax			;ebx = average z for this face

	mov	ds:[ebp],edi		;adress==no du poly
	mov	ds:[ebp+4],ebx		;average z

	add	ebp,8
	add	edi,6

	dec	ecx
	jnz	@@calc_z

;bubble-sort!
	mov	edi,((nb_face_des-1)*8)+offset buf_work
@@lp_bub:
	mov	esi,offset buf_work
	mov	ecx,1
@@lp_bubble:
	mov	eax,ds:[esi+4]		;z1
	mov	ebx,ds:[esi+12]		;z2
	cmp	eax,ebx
	jge	@@no_swap
	mov	ds:[esi+4],ebx
	mov	ds:[esi+12],eax		;swap z
	mov	eax,ds:[esi]		;adr1
	mov	ebx,ds:[esi+8]		;adr2
	mov	ds:[esi],ebx
	mov	ds:[esi+8],eax		;swap adr
	xor	ecx,ecx
@@no_swap:	add	esi,8
	cmp	esi,edi
	jnz	@@lp_bubble
	sub	edi,8
	jecxz	@@lp_bub

;copy buffer
	mov	esi,offset buf_work
	mov	edi,pt_sort
	mov	ecx,nb_face_des
@@lp_rec_s:
	mov	eax,ds:[esi]		;adr
	mov	ds:[edi],eax
	add	esi,8
	add	edi,4
	dec	ecx
	jnz	@@lp_rec_s
	mov	pt_sort,edi

@@suite_sort:
	pop	esi
	add	esi,3*4
	pop	ecx
	dec	ecx
	jnz     @@lp_init
@@fin_sort:	ret


;DATA

dat_sort	dd	512/2, 512/2, 0
	dd	-512/2, 512/2, 0
	dd	-512/2, -512/2, 0
	dd	512/2, -512/2, 0
	dd	512/2+1048, 512/2, 1048
	dd	-512/2+1048, 512/2, 1048
	dd	-512/2+1048, -512/2, 1048
	dd	512/2+1048, -512/2, 1048

control_table:
	dd	offset buf_sort+nb_face_des*3*4
	dd	offset buf_sort
	dd	offset buf_sort+nb_face_des*4*2
	dd	offset buf_sort+nb_face_des*1*4
	dd	offset buf_sort+nb_face_des*4*4
	dd	offset buf_sort+nb_face_des*4*7
	dd	offset buf_sort+nb_face_des*4*5
	dd	offset buf_sort+nb_face_des*4*6

	include	duck.pts

;BSS

pt_sort		dd	(?)
buf_work		dd	nb_face_des*2	dup	(?)
buf_sort		dd	nb_face_des*8	dup	(?)
ctrl_rot		dw	3*3		dup	(?)

